Index: /branches/thasling/DistributedGA/DistributedGA.ContactServer.Host/Program.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.ContactServer.Host/Program.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.ContactServer.Host/Program.cs	(revision 13924)
@@ -2,39 +2,33 @@
 using System.ServiceModel;
 
-namespace DistributedGA.ContactServer.Host
-{
-    class Program
-    {
-        static void Main(string[] args)
-        {
-            string baseAddress = string.Empty;
-            if (args.GetUpperBound(0) > -1)
-            {
-                baseAddress = args[0];
-            }
-            if (string.IsNullOrWhiteSpace(baseAddress))
-            {
-                baseAddress = "net.tcp://localhost:9090/DistributedGA.ContactServer/ContactService";
-            }
-            using (ServiceHost host = new ServiceHost(typeof(ContactServiceImpl), new Uri[] { new Uri(baseAddress) }))
-            {
-                // Enable metadata publishing.
+namespace DistributedGA.ContactServer.Host {
+  class Program {
+    static void Main(string[] args) {
+      string baseAddress = string.Empty;
+      if (args.GetUpperBound(0) > -1) {
+        baseAddress = args[0];
+      }
+      if (string.IsNullOrWhiteSpace(baseAddress)) {
+        baseAddress = "net.tcp://localhost:9090/DistributedGA.ContactServer/ContactService";
+      }
+      using (ServiceHost host = new ServiceHost(typeof(ContactServiceImpl), new Uri[] { new Uri(baseAddress) })) {
+        // Enable metadata publishing.
 
 
-                // Open the ServiceHost to start listening for messages. Since
-                // no endpoints are explicitly configured, the runtime will create
-                // one endpoint per base address for each service contract implemented
-                // by the service.
+        // Open the ServiceHost to start listening for messages. Since
+        // no endpoints are explicitly configured, the runtime will create
+        // one endpoint per base address for each service contract implemented
+        // by the service.
 
-                host.Open();
+        host.Open();
 
-                Console.WriteLine("The service is ready at {0}", baseAddress);
-                Console.WriteLine("Press <Enter> to stop the service.");
-                Console.ReadLine();
+        Console.WriteLine("The service is ready at {0}", baseAddress);
+        Console.WriteLine("Press <Enter> to stop the service.");
+        Console.ReadLine();
 
-                // Close the ServiceHost.
-                host.Close();
-            }
-        }
+        // Close the ServiceHost.
+        host.Close();
+      }
     }
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.ContactServer/ContactServiceImpl.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.ContactServer/ContactServiceImpl.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.ContactServer/ContactServiceImpl.cs	(revision 13924)
@@ -30,5 +30,6 @@
       try {
         UpdateHeartbeat(source);
-      } catch (Exception ex) {
+      }
+      catch (Exception ex) {
         AddError("ContactServiceImpl.RegisterPeer", ex);
       }
@@ -46,5 +47,6 @@
             return false;
         }).ToList();
-      } catch (Exception ex) {
+      }
+      catch (Exception ex) {
         AddError("ContactServiceImpl.GetPeerList", ex);
         return null;
@@ -58,5 +60,6 @@
           File.AppendAllText("Log.txt", string.Concat(source.IpAddress, ":", source.Port, ",", source.ProblemInstance, ",", msg, Environment.NewLine));
         }
-      } catch (Exception ex) {
+      }
+      catch (Exception ex) {
         //Nothing to do because maybe called from adderror
       }
@@ -68,5 +71,6 @@
         DateTime now = DateTime.Now;
         allPeers.AddOrUpdate(source, now, (k, v) => v = now);
-      } catch (Exception ex) {
+      }
+      catch (Exception ex) {
         AddError("ContactServiceImpl.UpdateHeartbeat", ex);
       }
Index: /branches/thasling/DistributedGA/DistributedGA.ContactServer/IContactService.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.ContactServer/IContactService.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.ContactServer/IContactService.cs	(revision 13924)
@@ -7,21 +7,19 @@
 using System.Threading.Tasks;
 
-namespace DistributedGA.ContactServer
-{
-    [ServiceContract]
-    public interface IContactService
-    {
-        [OperationContract]
-        void RegisterPeer(PeerInfo source); //Registers own instance at the contact-server
+namespace DistributedGA.ContactServer {
+  [ServiceContract]
+  public interface IContactService {
+    [OperationContract]
+    void RegisterPeer(PeerInfo source); //Registers own instance at the contact-server
 
-        [OperationContract]
-        List<PeerInfo> GetPeerList(PeerInfo source); //Recieves all peers in the network from contact-server
+    [OperationContract]
+    List<PeerInfo> GetPeerList(PeerInfo source); //Recieves all peers in the network from contact-server
 
-        [OperationContract]
-        void UpdateHeartbeat(PeerInfo source); //Sends heartbeat to contact-server
+    [OperationContract]
+    void UpdateHeartbeat(PeerInfo source); //Sends heartbeat to contact-server
 
-        [OperationContract]
-        void MakeLog(PeerInfo source, string msg); //Used to log all peers at a single location
+    [OperationContract]
+    void MakeLog(PeerInfo source, string msg); //Used to log all peers at a single location
 
-    }
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Domain/MessageRecieveEventArgs.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Domain/MessageRecieveEventArgs.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Domain/MessageRecieveEventArgs.cs	(revision 13924)
@@ -1,11 +1,9 @@
 ﻿using System;
 
-namespace DistributedGA.Core.Domain
-{
-    public class MessageRecieveEventArgs : EventArgs
-    {
-        public int val;
-        public byte[][] data { get; set; }
-        public PeerInfo Sender { get; set; }
-    }
+namespace DistributedGA.Core.Domain {
+  public class MessageRecieveEventArgs : EventArgs {
+    public int val;
+    public byte[][] data { get; set; }
+    public PeerInfo Sender { get; set; }
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Domain/PeerInfo.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Domain/PeerInfo.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Domain/PeerInfo.cs	(revision 13924)
@@ -5,32 +5,26 @@
 using System.Threading.Tasks;
 
-namespace DistributedGA.Core.Domain
-{
-    //containts contact information of one peer
-    public class PeerInfo
-    {
-        public int Port { get; set; }
-        public string IpAddress { get; set; }
-        public string ProblemInstance { get; set; }
+namespace DistributedGA.Core.Domain {
+  //containts contact information of one peer
+  public class PeerInfo {
+    public int Port { get; set; }
+    public string IpAddress { get; set; }
+    public string ProblemInstance { get; set; }
 
-        public override bool Equals(System.Object obj)
-        {
-            if (obj == null)
-            {
-                return false;
-            }
+    public override bool Equals(System.Object obj) {
+      if (obj == null) {
+        return false;
+      }
 
-            PeerInfo p = obj as PeerInfo;
-            if ((System.Object)p == null)
-            {
-                return false;
-            }
+      PeerInfo p = obj as PeerInfo;
+      if ((System.Object)p == null) {
+        return false;
+      }
 
-            return p.Port.Equals(this.Port) && p.IpAddress.Equals(this.IpAddress);
-        }
-        public override int GetHashCode()
-        {
-            return this.IpAddress.GetHashCode();
-        }
+      return p.Port.Equals(this.Port) && p.IpAddress.Equals(this.IpAddress);
     }
+    public override int GetHashCode() {
+      return this.IpAddress.GetHashCode();
+    }
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/MessageContractImpl.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/MessageContractImpl.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/MessageContractImpl.cs	(revision 13924)
@@ -4,21 +4,17 @@
 using DistributedGA.Core.Interface;
 
-namespace DistributedGA.Core.Implementation
-{
-    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
-    public class MessageContractImpl : IMessageContract
-    {
-        public void SendData(PeerInfo sender, byte[][] data)
-        {
-            MessageRecieveEventArgs args = new MessageRecieveEventArgs() { Sender = sender, data = data };
+namespace DistributedGA.Core.Implementation {
+  [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
+  public class MessageContractImpl : IMessageContract {
+    public void SendData(PeerInfo sender, byte[][] data) {
+      MessageRecieveEventArgs args = new MessageRecieveEventArgs() { Sender = sender, data = data };
 
-            if (MessageRecieved != null)
-            {
-                MessageRecieved(this, args);
-            }
-        }
+      if (MessageRecieved != null) {
+        MessageRecieved(this, args);
+      }
+    }
 
-        public event EventHandler<MessageRecieveEventArgs> MessageRecieved;
+    public event EventHandler<MessageRecieveEventArgs> MessageRecieved;
 
-    }
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/PeerNetworkMessageHandler.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/PeerNetworkMessageHandler.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/PeerNetworkMessageHandler.cs	(revision 13924)
@@ -7,179 +7,147 @@
 using DistributedGA.Core.Interface;
 
-namespace DistributedGA.Core.Implementation
-{
-    public class PeerNetworkMessageHandler : IMessageHandler
-    {
-        //own peer-instance Information
-        private PeerInfo ownInstance = null;
+namespace DistributedGA.Core.Implementation {
+  public class PeerNetworkMessageHandler : IMessageHandler {
+    //own peer-instance Information
+    private PeerInfo ownInstance = null;
 
-        //uses peer-list from IPeerListManager to decide which peers to contact
-        private IPeerListManager peerListManager;
+    //uses peer-list from IPeerListManager to decide which peers to contact
+    private IPeerListManager peerListManager;
 
-        //uses IMessageSender to send populations to peers
-        private IMessageSender sender = null;
+    //uses IMessageSender to send populations to peers
+    private IMessageSender sender = null;
 
-        //provides current population for the higher layer IMigrationOperator
-        //to queues are used to gather and and provide population more efficiently
-        private object activeQueueLocker = new object();
-        private ConcurrentQueue<byte[]> writeQueue;
-        private ConcurrentQueue<byte[]> readQueue;
+    //provides current population for the higher layer IMigrationOperator
+    //to queues are used to gather and and provide population more efficiently
+    private object activeQueueLocker = new object();
+    private ConcurrentQueue<byte[]> writeQueue;
+    private ConcurrentQueue<byte[]> readQueue;
 
-        //uses IMessageService for recieving population from one peer at once
-        private IMessageService host = null;
+    //uses IMessageService for recieving population from one peer at once
+    private IMessageService host = null;
 
 
 
-        public void Init(string lanIpPrefix, string contactServerUrl)
-        {
-            try
-            {
-                ownInstance = new PeerInfo()
-                {
-                    IpAddress = GetInternalIpAddress(lanIpPrefix),
-                    Port = 0,
-                    ProblemInstance = "TestProblem"
-                }; // TODO: get own peerinfo
+    public void Init(string lanIpPrefix, string contactServerUrl) {
+      try {
+        ownInstance = new PeerInfo() {
+          IpAddress = GetInternalIpAddress(lanIpPrefix),
+          Port = 0,
+          ProblemInstance = "TestProblem"
+        }; // TODO: get own peerinfo
 
-                writeQueue = new ConcurrentQueue<byte[]>();
-                readQueue = new ConcurrentQueue<byte[]>();
+        writeQueue = new ConcurrentQueue<byte[]>();
+        readQueue = new ConcurrentQueue<byte[]>();
 
 
-                host = new WcfMessageService();
-                ownInstance.Port = host.Init(ownInstance.IpAddress); //getting port, on which service is hostet
-                host.OnDataRecieved += new EventHandler<MessageRecieveEventArgs>(OnPopulationRecieved);
+        host = new WcfMessageService();
+        ownInstance.Port = host.Init(ownInstance.IpAddress); //getting port, on which service is hostet
+        host.OnDataRecieved += new EventHandler<MessageRecieveEventArgs>(OnPopulationRecieved);
 
-                peerListManager = new WcfPeerListManager();
-                peerListManager.Init(ownInstance, contactServerUrl);
+        peerListManager = new WcfPeerListManager();
+        peerListManager.Init(ownInstance, contactServerUrl);
 
-                sender = new WcfMessageSender();
-                sender.Init(ownInstance);
+        sender = new WcfMessageSender();
+        sender.Init(ownInstance);
 
-            }
-            catch (Exception ex)
-            {
-                AddError("PeerNetworkMessageHandler.Init", ex);
-            }
+      }
+      catch (Exception ex) {
+        AddError("PeerNetworkMessageHandler.Init", ex);
+      }
+    }
+
+    public void Dispose() {
+      try {
+        host.Dispose();
+        sender.Dispose();
+        peerListManager.Dispose();
+      }
+      catch (Exception ex) {
+        AddError("PeerNetworkMessageHandler.Dispose", ex);
+      }
+    }
+
+    public void PublishDataToNetwork(byte[][] data) {
+      try {
+        foreach (PeerInfo peer in peerListManager.GetPeerList()) {
+          //maybe something will go wrong during network communication...
+          try {
+            sender.SendData(peer, data);
+          }
+          catch (Exception ex) {
+            AddError("PeerNetworkMessageHandler.PublishDataToNetwork(during sending to one peer!)", ex);
+          }
+        }
+      }
+      catch (Exception ex) {
+        AddError("PeerNetworkMessageHandler.PublishDataToNetwork", ex);
+      }
+    }
+
+    public byte[][] GetDataFromNetwork() {
+      try {
+        List<byte[]> res = new List<byte[]>();
+        byte[] item = null;
+        lock (activeQueueLocker) {
+          var tmp = readQueue;
+          readQueue = writeQueue;
+          writeQueue = tmp;
         }
 
-        public void Dispose()
-        {
-            try
-            {
-                host.Dispose();
-                sender.Dispose();
-                peerListManager.Dispose();
-            }
-            catch (Exception ex)
-            {
-                AddError("PeerNetworkMessageHandler.Dispose", ex);
-            }
+        //creating resultset
+        while (!readQueue.IsEmpty) {
+          if (readQueue.TryDequeue(out item)) {
+            res.Add(item);
+          }
         }
+        return res.ToArray();
+      }
+      catch (Exception ex) {
+        AddError("PeerNetworkMessageHandler.GetDataFromNetwork", ex);
+        return null;
+      }
+    }
 
-        public void PublishDataToNetwork(byte[][] data)
-        {
-            try
-            {
-                foreach (PeerInfo peer in peerListManager.GetPeerList())
-                {
-                    //maybe something will go wrong during network communication...
-                    try
-                    {
-                        sender.SendData(peer, data);
-                    }
-                    catch (Exception ex)
-                    {
-                        AddError("PeerNetworkMessageHandler.PublishDataToNetwork(during sending to one peer!)", ex);
-                    }
-                }
-            }
-            catch (Exception ex)
-            {
-                AddError("PeerNetworkMessageHandler.PublishDataToNetwork", ex);
-            }
+    public PeerInfo GetPeerInfo() {
+      return ownInstance;
+    }
+
+    public List<PeerInfo> GetCurrentNetwork() {
+      return peerListManager.GetPeerList();
+    }
+
+    private string GetInternalIpAddress(string ipPrefix) {
+      try {
+        var strHostName = Dns.GetHostName();
+        // Then using host name, get the IP address list..
+        IPHostEntry ipEntry = Dns.GetHostEntry(strHostName);
+        IPAddress[] addr = ipEntry.AddressList;
+
+        return addr
+          .Select(ip => ip.ToString())
+          .First(str => str.StartsWith(ipPrefix));
+      }
+      catch { return null; }
+    }
+
+    private void OnPopulationRecieved(object sender, MessageRecieveEventArgs e) {
+      if (e != null) {
+        lock (activeQueueLocker) {
+          foreach (byte[] item in e.data) {
+            writeQueue.Enqueue(item);
+          }
         }
+      }
+    }
 
-        public byte[][] GetDataFromNetwork()
-        {
-            try
-            {
-                List<byte[]> res = new List<byte[]>();
-                byte[] item = null;
-                lock (activeQueueLocker)
-                {
-                    var tmp = readQueue;
-                    readQueue = writeQueue;
-                    writeQueue = tmp;
-                }
+    private void AddError(string source, Exception ex) {
+      if (peerListManager != null) {
+        try {
+          peerListManager.SendLogToServer(string.Concat("Source: ", source, ", Exception: ", ex.Message));
+        }
+        catch { }
+      }
+    }
 
-                //creating resultset
-                while (!readQueue.IsEmpty)
-                {
-                    if (readQueue.TryDequeue(out item))
-                    {
-                        res.Add(item);
-                    }
-                }
-                return res.ToArray();
-            }
-            catch (Exception ex)
-            {
-                AddError("PeerNetworkMessageHandler.GetDataFromNetwork", ex);
-                return null;
-            }
-        }
-
-        public PeerInfo GetPeerInfo()
-        {
-            return ownInstance;
-        }
-
-        public List<PeerInfo> GetCurrentNetwork()
-        {
-            return peerListManager.GetPeerList();
-        }
-
-        private string GetInternalIpAddress(string ipPrefix)
-        {
-            try
-            {
-                var strHostName = Dns.GetHostName();
-                // Then using host name, get the IP address list..
-                IPHostEntry ipEntry = Dns.GetHostEntry(strHostName);
-                IPAddress[] addr = ipEntry.AddressList;
-
-                return addr
-                  .Select(ip => ip.ToString())
-                  .First(str => str.StartsWith(ipPrefix));
-            }
-            catch { return null; }
-        }
-
-        private void OnPopulationRecieved(object sender, MessageRecieveEventArgs e)
-        {
-            if (e != null)
-            {
-                lock (activeQueueLocker)
-                {
-                    foreach (byte[] item in e.data)
-                    {
-                        writeQueue.Enqueue(item);
-                    }
-                }
-            }
-        }
-
-        private void AddError(string source, Exception ex)
-        {
-            if (peerListManager != null)
-            {
-                try
-                {
-                    peerListManager.SendLogToServer(string.Concat("Source: ", source, ", Exception: ", ex.Message));
-                }
-                catch { }
-            }
-        }
-
-    }
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageService.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageService.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageService.cs	(revision 13924)
@@ -7,62 +7,53 @@
 using DistributedGA.Core.Interface;
 
-namespace DistributedGA.Core.Implementation
-{
-    public class WcfMessageService : IMessageService
-    {
-        public event EventHandler<MessageRecieveEventArgs> OnDataRecieved;
+namespace DistributedGA.Core.Implementation {
+  public class WcfMessageService : IMessageService {
+    public event EventHandler<MessageRecieveEventArgs> OnDataRecieved;
 
-        private static ManualResetEvent _ResetEvent = new ManualResetEvent(false);
+    private static ManualResetEvent _ResetEvent = new ManualResetEvent(false);
 
-        private IMessageContract messageContract = null;
+    private IMessageContract messageContract = null;
 
-        public int Init(string ip)
-        {
-            int port = 0;
-            port = FreeTcpPort();
+    public int Init(string ip) {
+      int port = 0;
+      port = FreeTcpPort();
 
-            messageContract = new MessageContractImpl();
-            messageContract.MessageRecieved += new EventHandler<MessageRecieveEventArgs>(OnMessageRecieved);
+      messageContract = new MessageContractImpl();
+      messageContract.MessageRecieved += new EventHandler<MessageRecieveEventArgs>(OnMessageRecieved);
 
-            var serviceUrl = "DistributedGA.svc";
-            new Thread(() =>
-            {
-                var baseUri = new Uri(string.Concat("net.tcp://", ip, ":", port, "/DistributedGA"));
-                var serviceUri = new Uri(baseUri, serviceUrl);
-                NetTcpBinding binding = new NetTcpBinding();
+      var serviceUrl = "DistributedGA.svc";
+      new Thread(() => {
+        var baseUri = new Uri(string.Concat("net.tcp://", ip, ":", port, "/DistributedGA"));
+        var serviceUri = new Uri(baseUri, serviceUrl);
+        NetTcpBinding binding = new NetTcpBinding();
 
-                using (var host = new ServiceHost(messageContract, serviceUri))
-                {
-                    host.AddServiceEndpoint(typeof(IMessageContract), binding, serviceUri);
+        using (var host = new ServiceHost(messageContract, serviceUri)) {
+          host.AddServiceEndpoint(typeof(IMessageContract), binding, serviceUri);
 
-                    host.Open();
+          host.Open();
 
-                    _ResetEvent.WaitOne();
-                }
-            }).Start();
-            return port;
+          _ResetEvent.WaitOne();
         }
+      }).Start();
+      return port;
+    }
 
-        public void Dispose()
-        {
-            _ResetEvent.Set();
-        }
+    public void Dispose() {
+      _ResetEvent.Set();
+    }
 
-        private int FreeTcpPort()
-        {
-            TcpListener l = new TcpListener(IPAddress.Loopback, 0);
-            l.Start();
-            int port = ((IPEndPoint)l.LocalEndpoint).Port;
-            l.Stop();
-            return port;
-        }
+    private int FreeTcpPort() {
+      TcpListener l = new TcpListener(IPAddress.Loopback, 0);
+      l.Start();
+      int port = ((IPEndPoint)l.LocalEndpoint).Port;
+      l.Stop();
+      return port;
+    }
 
-        private void OnMessageRecieved(object sender, MessageRecieveEventArgs e)
-        {
-            if (OnDataRecieved != null)
-            {
-                OnDataRecieved(this, e);
-            }
-        }
+    private void OnMessageRecieved(object sender, MessageRecieveEventArgs e) {
+      if (OnDataRecieved != null) {
+        OnDataRecieved(this, e);
+      }
     }
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IContactService.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IContactService.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IContactService.cs	(revision 13924)
@@ -7,21 +7,19 @@
 using System.Threading.Tasks;
 
-namespace DistributedGA.Core.Interface
-{
-    [ServiceContract]
-    public interface IContactService
-    {
-        [OperationContract]
-        void RegisterPeer(PeerInfo source); //Registers own instance at the contact-server
+namespace DistributedGA.Core.Interface {
+  [ServiceContract]
+  public interface IContactService {
+    [OperationContract]
+    void RegisterPeer(PeerInfo source); //Registers own instance at the contact-server
 
-        [OperationContract]
-        List<PeerInfo> GetPeerList(PeerInfo source); //Recieves all peers in the network from contact-server
+    [OperationContract]
+    List<PeerInfo> GetPeerList(PeerInfo source); //Recieves all peers in the network from contact-server
 
-        [OperationContract]
-        void UpdateHeartbeat(PeerInfo source); //Sends heartbeat to contact-server
+    [OperationContract]
+    void UpdateHeartbeat(PeerInfo source); //Sends heartbeat to contact-server
 
-        [OperationContract]
-        void MakeLog(PeerInfo source, string msg); //Used to log all peers at a single location
+    [OperationContract]
+    void MakeLog(PeerInfo source, string msg); //Used to log all peers at a single location
 
-    }
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageContract.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageContract.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageContract.cs	(revision 13924)
@@ -3,15 +3,13 @@
 using DistributedGA.Core.Domain;
 
-namespace DistributedGA.Core.Interface
-{
+namespace DistributedGA.Core.Interface {
 
-    [ServiceContract]
-    public interface IMessageContract
-    {
+  [ServiceContract]
+  public interface IMessageContract {
 
-        [OperationContract]
-        void SendData(PeerInfo sender, byte[][] data);
+    [OperationContract]
+    void SendData(PeerInfo sender, byte[][] data);
 
-        event EventHandler<MessageRecieveEventArgs> MessageRecieved;
-    }
+    event EventHandler<MessageRecieveEventArgs> MessageRecieved;
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageHandler.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageHandler.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageHandler.cs	(revision 13924)
@@ -2,21 +2,19 @@
 using DistributedGA.Core.Domain;
 
-namespace DistributedGA.Core.Interface
-{
+namespace DistributedGA.Core.Interface {
 
-    public interface IMessageHandler
-    {
+  public interface IMessageHandler {
 
-        void Init(string lanIpPrefix, string contactServerUrl); //Registers at contract-server
+    void Init(string lanIpPrefix, string contactServerUrl); //Registers at contract-server
 
-        void PublishDataToNetwork(byte[][] data);
+    void PublishDataToNetwork(byte[][] data);
 
-        byte[][] GetDataFromNetwork();
+    byte[][] GetDataFromNetwork();
 
-        PeerInfo GetPeerInfo();
+    PeerInfo GetPeerInfo();
 
-        List<PeerInfo> GetCurrentNetwork();
+    List<PeerInfo> GetCurrentNetwork();
 
-        void Dispose();
-    }
+    void Dispose();
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageSender.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageSender.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageSender.cs	(revision 13924)
@@ -1,15 +1,13 @@
 ﻿using DistributedGA.Core.Domain;
 
-namespace DistributedGA.Core.Interface
-{
+namespace DistributedGA.Core.Interface {
 
-    public interface IMessageSender
-    {
+  public interface IMessageSender {
 
-        void Init(PeerInfo source);
+    void Init(PeerInfo source);
 
-        void SendData(PeerInfo destination, byte[][] data);
+    void SendData(PeerInfo destination, byte[][] data);
 
-        void Dispose();
-    }
+    void Dispose();
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageService.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageService.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageService.cs	(revision 13924)
@@ -2,20 +2,18 @@
 using DistributedGA.Core.Domain;
 
-namespace DistributedGA.Core.Interface
-{
+namespace DistributedGA.Core.Interface {
 
-    public interface IMessageService
-    {
+  public interface IMessageService {
 
-        /// <summary>
-        /// Initializes a WCF service and host it with another thread
-        /// </summary>
-        /// <param name="ip">current external ip address</param>
-        /// <returns>The port, on which the service was successfully hosted</returns>
-        int Init(string ip);
+    /// <summary>
+    /// Initializes a WCF service and host it with another thread
+    /// </summary>
+    /// <param name="ip">current external ip address</param>
+    /// <returns>The port, on which the service was successfully hosted</returns>
+    int Init(string ip);
 
-        void Dispose();
+    void Dispose();
 
-        event EventHandler<MessageRecieveEventArgs> OnDataRecieved;
-    }
+    event EventHandler<MessageRecieveEventArgs> OnDataRecieved;
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IPeerListManager.cs
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IPeerListManager.cs	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.Core/Interface/IPeerListManager.cs	(revision 13924)
@@ -2,17 +2,15 @@
 using DistributedGA.Core.Domain;
 
-namespace DistributedGA.Core.Interface
-{
+namespace DistributedGA.Core.Interface {
 
-    public interface IPeerListManager
-    {
+  public interface IPeerListManager {
 
-        void Init(PeerInfo source, string contactServerUrl); //Registers own instance at the contact-server
+    void Init(PeerInfo source, string contactServerUrl); //Registers own instance at the contact-server
 
-        List<PeerInfo> GetPeerList(); //Recieves all peers in the network from contact-server
+    List<PeerInfo> GetPeerList(); //Recieves all peers in the network from contact-server
 
-        void SendLogToServer(string msg);
+    void SendLogToServer(string msg);
 
-        void Dispose();
-    }
+    void Dispose();
+  }
 }
Index: /branches/thasling/DistributedGA/DistributedGA.sln
===================================================================
--- /branches/thasling/DistributedGA/DistributedGA.sln	(revision 13923)
+++ /branches/thasling/DistributedGA/DistributedGA.sln	(revision 13924)
@@ -2,11 +2,9 @@
 Microsoft Visual Studio Solution File, Format Version 12.00
 # Visual Studio 2013
-VisualStudioVersion = 12.0.31101.0
+VisualStudioVersion = 12.0.21005.1
 MinimumVisualStudioVersion = 10.0.40219.1
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "DistributedGA.Test", "DistributedGA.Test\DistributedGA.Test.csproj", "{E0E91C06-C56A-454F-9F7C-3FA7AE7F920E}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "DistributedGA.Core", "DistributedGA.Core\DistributedGA.Core.csproj", "{02E73F42-BDC9-4A7A-B74F-5879DEF27320}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "DistributedGA.Operator", "DistributedGA.Operator\DistributedGA.Operator.csproj", "{2443717F-222B-41AB-AC69-0EF69E83765F}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "DistributedGA.ContactServer", "DistributedGA.ContactServer\DistributedGA.ContactServer.csproj", "{554DAD06-0BF9-4908-BD62-D5FDC46A8B74}"
@@ -32,8 +30,4 @@
 		{02E73F42-BDC9-4A7A-B74F-5879DEF27320}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{02E73F42-BDC9-4A7A-B74F-5879DEF27320}.Release|Any CPU.Build.0 = Release|Any CPU
-		{2443717F-222B-41AB-AC69-0EF69E83765F}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{2443717F-222B-41AB-AC69-0EF69E83765F}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{2443717F-222B-41AB-AC69-0EF69E83765F}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{2443717F-222B-41AB-AC69-0EF69E83765F}.Release|Any CPU.Build.0 = Release|Any CPU
 		{554DAD06-0BF9-4908-BD62-D5FDC46A8B74}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{554DAD06-0BF9-4908-BD62-D5FDC46A8B74}.Debug|Any CPU.Build.0 = Debug|Any CPU