Index: /trunk/sources/HeuristicLab.ExtLibs.sln
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs.sln	(revision 13932)
+++ /trunk/sources/HeuristicLab.ExtLibs.sln	(revision 13933)
@@ -2,5 +2,5 @@
 Microsoft Visual Studio Solution File, Format Version 12.00
 # Visual Studio 2013
-VisualStudioVersion = 12.0.31101.0
+VisualStudioVersion = 12.0.40629.0
 MinimumVisualStudioVersion = 10.0.40219.1
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.DayView-1.0", "HeuristicLab.ExtLibs\HeuristicLab.DayView\1.0\HeuristicLab.DayView-1.0.csproj", "{02766ECC-D0F5-4115-9ECA-47409167B638}"
@@ -17,6 +17,4 @@
 	EndProjectSection
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.MathJax-1.1", "HeuristicLab.ExtLibs\HeuristicLab.MathJax\1.1\HeuristicLab.MathJax-1.1\HeuristicLab.MathJax-1.1.csproj", "{BF4C452F-4903-44E6-89B7-DF93D02C4819}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "ProtocolBuffers-2.4.1.473", "HeuristicLab.ExtLibs\HeuristicLab.ProtobufCS\2.4.1\ProtobufCS\src\ProtocolBuffers\ProtocolBuffers-2.4.1.473.csproj", "{6908BDCE-D925-43F3-94AC-A531E6DF2591}"
 EndProject
@@ -72,4 +70,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.SimSharp-3.0.7", "HeuristicLab.ExtLibs\HeuristicLab.SimSharp\3.0.7\HeuristicLab.SimSharp-3.0.7\HeuristicLab.SimSharp-3.0.7.csproj", "{5C93CAF7-AE6A-4540-95B2-5DA6761A2677}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.MathJax-2.6.1", "HeuristicLab.ExtLibs\HeuristicLab.MathJax\2.6.1\HeuristicLab.MathJax-2.6.1\HeuristicLab.MathJax-2.6.1.csproj", "{BCDA17A6-5B4A-495C-B182-E856CA081BE6}"
 EndProject
 Global
@@ -131,16 +131,4 @@
 		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x86.ActiveCfg = Release|x86
 		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x86.Build.0 = Release|x86
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Debug|x64.ActiveCfg = Debug|x64
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Debug|x64.Build.0 = Debug|x64
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Debug|x86.ActiveCfg = Debug|x86
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Debug|x86.Build.0 = Debug|x86
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Release|Any CPU.Build.0 = Release|Any CPU
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Release|x64.ActiveCfg = Release|x64
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Release|x64.Build.0 = Release|x64
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Release|x86.ActiveCfg = Release|x86
-		{BF4C452F-4903-44E6-89B7-DF93D02C4819}.Release|x86.Build.0 = Release|x86
 		{6908BDCE-D925-43F3-94AC-A531E6DF2591}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{6908BDCE-D925-43F3-94AC-A531E6DF2591}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -467,4 +455,16 @@
 		{5C93CAF7-AE6A-4540-95B2-5DA6761A2677}.Release|x86.ActiveCfg = Release|x86
 		{5C93CAF7-AE6A-4540-95B2-5DA6761A2677}.Release|x86.Build.0 = Release|x86
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Debug|x64.ActiveCfg = Debug|x64
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Debug|x64.Build.0 = Debug|x64
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Debug|x86.ActiveCfg = Debug|x86
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Debug|x86.Build.0 = Debug|x86
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Release|Any CPU.Build.0 = Release|Any CPU
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Release|x64.ActiveCfg = Release|x64
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Release|x64.Build.0 = Release|x64
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Release|x86.ActiveCfg = Release|x86
+		{BCDA17A6-5B4A-495C-B182-E856CA081BE6}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/MathSymbolicDataAnalysisModelView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/MathSymbolicDataAnalysisModelView.cs	(revision 13932)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/MathSymbolicDataAnalysisModelView.cs	(revision 13933)
@@ -65,5 +65,4 @@
         newElement.InnerText = string.Empty;
       }
-      webBrowser.Document.InvokeScript("refreshModel");
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/displayModelFrame.html
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/displayModelFrame.html	(revision 13932)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/displayModelFrame.html	(revision 13933)
@@ -1,53 +1,43 @@
-﻿<!-- this file is derived from sample.html from the MathJax distribution -->
-<!-- Copyright (c) 2009-2011 Design Science, Inc. -->
+﻿<!-- this file is derived from sample_tex.html from the MathJax distribution -->
+<!-- Copyright (c) 2010-2015 The MathJax Consortium -->
 <!-- adapted by HEAL for HeuristicLab-->
 <!DOCTYPE html>
 <html>
 <head>
-  <!-- title change by HEAL -->
-  <title>Symbolic Expression Tree</title>
-  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
-  <meta http-equiv="X-UA-Compatible" content="IE=EmulateIE7" />
-  <script type="text/x-mathjax-config">
-  MathJax.Hub.Config({
-    extensions: ["tex2jax.js", "TeX/AMSmath.js", "TeX/AMSsymbols.js"],
-    jax: ["input/TeX","output/HTML-CSS"],
-    tex2jax: {inlineMath: [["$","$"],["\\(","\\)"]]},
-    imageFont: null
-  });
-  
-</script>
-  <script type="text/javascript" src="./MathJax.js"></script>
-  <!-- begin changes by HEAL -->
-  <script type="text/javascript">
-  function refreshModel() {
-    var model = document.getElementById("model");
-    MathJax.Hub.Queue(["Typeset",MathJax.Hub,model]);
-  }
-</script>
-  <!-- end changes by HEAL -->
-  <style>
-h1 {text-align:center}
-h2 {
-  font-weight: bold;
-  background-color: #DDDDDD;
-  padding: .2em .5em;
-  margin-top: 1.5em;
-  border-top: 3px solid #666666;
-  border-bottom: 2px solid #999999;
-}
-</style>
+    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
+    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
+    <meta name="viewport" content="width=device-width, initial-scale=1">
+
+    <!-- title change by HEAL -->
+    <title>Symbolic Expression Tree</title>
+
+    <script type="text/x-mathjax-config">
+        MathJax.Hub.Config({
+        extensions: ["tex2jax.js", "TeX/AMSmath.js", "TeX/AMSsymbols.js"],
+        jax: ["input/TeX","output/SVG"],
+        tex2jax: {inlineMath: [["$","$"],["\\(","\\)"]]},
+        "HTML-CSS": {preferredFont: "STIX-Web"},
+        MathMenu: { showLocale:false},
+        imageFont: null
+        });
+    </script>
+
+    <script type="text/javascript" async
+            src="./MathJax/MathJax.js?config=TeX-AMS_SVG&locale=en">
+    </script>
 </head>
 <body id="body">
-  <noscript>
-    <div style="color: #CC0000; text-align: center">
-      <b>Warning: <a href="http://www.mathjax.org/">MathJax</a> requires JavaScript to process
-        the mathematics on this page.<br />
-        If your browser supports JavaScript, be sure it is enabled.</b>
-    </div>
-    <hr>
-  </noscript>
-  <p id="model">
-  </p>
+    <noscript>
+        <div style="color: #CC0000; text-align: center">
+            <b>
+                Warning: <a href="http://www.mathjax.org/">MathJax</a> requires JavaScript to process
+                the mathematics on this page.<br />
+                If your browser supports JavaScript, be sure it is enabled.
+            </b>
+        </div>
+        <hr>
+    </noscript>
+    <p id="model">
+    </p>
 </body>
 </html>
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs	(revision 13932)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Formatters/SymbolicDataAnalysisExpressionLatexFormatter.cs	(revision 13933)
@@ -403,5 +403,5 @@
             var constStr = string.Format(System.Globalization.NumberFormatInfo.InvariantInfo, "{0:G5}", constant);
             if (!constStr.Contains(".")) constStr = constStr + ".0";
-            constStr = constStr.Replace(".", "\\negthickspace&.");  // fix problem in rendering of aligned expressions
+            constStr = constStr.Replace(".", "&.");  // fix problem in rendering of aligned expressions
             strBuilder.Append("c_{" + i + "}& = & " + constStr);
             strBuilder.Append(@"\\");