Index: /trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 13934)
+++ /trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 13935)
@@ -146,6 +146,6 @@
         logic.GetColumnTypeAsString(columnIndex),
         logic.GetMissingValueCount(columnIndex).ToString(),
-        logic.GetMin<double>(columnIndex).ToString(),
-        logic.GetMax<double>(columnIndex).ToString(),
+        logic.GetMin<double>(columnIndex,double.NaN).ToString(),
+        logic.GetMax<double>(columnIndex,double.NaN).ToString(),
         logic.GetMedian(columnIndex).ToString(),
         logic.GetAverage(columnIndex).ToString(),
@@ -154,5 +154,5 @@
         logic.GetOneQuarterPercentile(columnIndex).ToString(),
         logic.GetThreeQuarterPercentile(columnIndex).ToString(),
-        logic.GetMostCommonValue<double>(columnIndex).ToString(),
+        logic.GetMostCommonValue<double>(columnIndex,double.NaN).ToString(),
         logic.GetDifferentValuesCount<double>(columnIndex).ToString()
       };
@@ -172,5 +172,5 @@
         "", //quarter percentile
         "", //three quarter percentile
-        logic.GetMostCommonValue<string>(columnIndex) ?? "",
+        logic.GetMostCommonValue<string>(columnIndex,string.Empty) ?? "",
         logic.GetDifferentValuesCount<string>(columnIndex).ToString()
       };
@@ -182,6 +182,6 @@
         logic.GetColumnTypeAsString(columnIndex),
         logic.GetMissingValueCount(columnIndex).ToString(),
-        logic.GetMin<DateTime>(columnIndex).ToString(),
-        logic.GetMax<DateTime>(columnIndex).ToString(),
+        logic.GetMin<DateTime>(columnIndex,DateTime.MinValue).ToString(),
+        logic.GetMax<DateTime>(columnIndex,DateTime.MinValue).ToString(),
         logic.GetMedianDateTime(columnIndex).ToString(),
         logic.GetAverageDateTime(columnIndex).ToString(),
@@ -190,5 +190,5 @@
         logic.GetOneQuarterPercentile(columnIndex).ToString(),
         logic.GetThreeQuarterPercentile(columnIndex).ToString(),
-        logic.GetMostCommonValue<DateTime>(columnIndex).ToString(),
+        logic.GetMostCommonValue<DateTime>(columnIndex,DateTime.MinValue).ToString(),
         logic.GetDifferentValuesCount<DateTime>(columnIndex).ToString()
       };
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/ManipulationLogic.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/ManipulationLogic.cs	(revision 13934)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/ManipulationLogic.cs	(revision 13935)
@@ -85,6 +85,6 @@
         foreach (var column in cells) {
           if (preprocessingData.VariableHasType<double>(column.Key)) {
-            double max = statisticsLogic.GetMax<double>(column.Key, considerSelection);
-            double min = statisticsLogic.GetMin<double>(column.Key, considerSelection);
+            double max = statisticsLogic.GetMax<double>(column.Key, double.NaN, considerSelection);
+            double min = statisticsLogic.GetMin<double>(column.Key, double.NaN, considerSelection);
             double randMultiplier = (max - min);
             foreach (int index in column.Value) {
@@ -93,6 +93,6 @@
             }
           } else if (preprocessingData.VariableHasType<DateTime>(column.Key)) {
-            DateTime min = statisticsLogic.GetMin<DateTime>(column.Key, considerSelection);
-            DateTime max = statisticsLogic.GetMax<DateTime>(column.Key, considerSelection);
+            DateTime min = statisticsLogic.GetMin<DateTime>(column.Key, DateTime.MinValue, considerSelection);
+            DateTime max = statisticsLogic.GetMax<DateTime>(column.Key, DateTime.MinValue, considerSelection);
             double randMultiplier = (max - min).TotalSeconds;
             foreach (int index in column.Value) {
@@ -213,9 +213,9 @@
         foreach (var column in cells) {
           if (preprocessingData.VariableHasType<double>(column.Key)) {
-            ReplaceIndicesByValue<double>(column.Key, column.Value, statisticsLogic.GetMostCommonValue<double>(column.Key, considerSelection));
+            ReplaceIndicesByValue<double>(column.Key, column.Value, statisticsLogic.GetMostCommonValue<double>(column.Key, double.NaN, considerSelection));
           } else if (preprocessingData.VariableHasType<string>(column.Key)) {
-            ReplaceIndicesByValue<string>(column.Key, column.Value, statisticsLogic.GetMostCommonValue<string>(column.Key, considerSelection));
+            ReplaceIndicesByValue<string>(column.Key, column.Value, statisticsLogic.GetMostCommonValue<string>(column.Key, string.Empty, considerSelection));
           } else if (preprocessingData.VariableHasType<DateTime>(column.Key)) {
-            ReplaceIndicesByValue<DateTime>(column.Key, column.Value, statisticsLogic.GetMostCommonValue<DateTime>(column.Key, considerSelection));
+            ReplaceIndicesByValue<DateTime>(column.Key, column.Value, statisticsLogic.GetMostCommonValue<DateTime>(column.Key, DateTime.MinValue, considerSelection));
           } else {
             throw new ArgumentException("column with index: " + column.Key + " contains a non supported type.");
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/StatisticsLogic.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/StatisticsLogic.cs	(revision 13934)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/StatisticsLogic.cs	(revision 13935)
@@ -71,6 +71,6 @@
     }
 
-    public T GetMin<T>(int columnIndex, bool considerSelection = false) where T : IComparable<T> {
-      var min = default(T);
+    public T GetMin<T>(int columnIndex, T defaultValue, bool considerSelection = false) where T : IComparable<T> {
+      var min = defaultValue;
       if (preprocessingData.VariableHasType<T>(columnIndex)) {
         var values = GetValuesWithoutNaN<T>(columnIndex, considerSelection);
@@ -82,6 +82,6 @@
     }
 
-    public T GetMax<T>(int columnIndex, bool considerSelection = false) where T : IComparable<T> {
-      var max = default(T);
+    public T GetMax<T>(int columnIndex, T defaultValue, bool considerSelection = false) where T : IComparable<T> {
+      var max = defaultValue;
       if (preprocessingData.VariableHasType<T>(columnIndex)) {
         var values = GetValuesWithoutNaN<T>(columnIndex, considerSelection);
@@ -131,8 +131,8 @@
     }
 
-    public T GetMostCommonValue<T>(int columnIndex, bool considerSelection = false) {
+    public T GetMostCommonValue<T>(int columnIndex, T defaultValue, bool considerSelection = false) {
       var values = GetValuesWithoutNaN<T>(columnIndex, considerSelection);
       if (!values.Any())
-        return default(T);
+        return defaultValue;
       return values.GroupBy(x => x)
                               .OrderByDescending(g => g.Count())